#Yokovic Remake
execute as @e[tag=aj.yokovic.root,tag=!scened] at @s run function ampsurv:boss/yokovic/scening
execute store result score @s boss.storage.yokovic run data get entity @e[tag=yokovic,limit=1,sort=nearest] Health
execute store result score @e[tag=host] boss.storage.yokovic run data get entity @e[tag=yokovic,limit=1,sort=nearest] Health

#Perma-effects
execute as @e[tag=yokovic,type=wither_skeleton] at @s anchored eyes run particle soul ~ ~ ~ 0.4 1 0.4 0 1 normal
execute as @e[tag=yokovic,type=wither_skeleton] at @s anchored eyes run particle dust_color_transition 0 0 0.3 2 0.3 0.3 0.3 ~ ~1 ~ 0.3 0.5 0.3 1 2 force
execute as @e[tag=yokovic,type=wither_skeleton] at @s anchored eyes run effect give @s invisibility 999999 1 true
execute as @e[tag=yokovic,tag=!res_down,type=wither_skeleton] at @s anchored eyes run effect give @s resistance 2 1 true
#Structural Construction
execute as @e[tag=yokovic_Entity,tag=!dying,type=wither_skeleton] at @s run tp @e[tag=aj.yokovic.root,limit=1,sort=nearest] ^ ^ ^-0.1 facing entity @e[tag=yokovic_Entity,limit=1,sort=nearest]
execute as @e[tag=yokovic_Entity,tag=!dying,type=wither_skeleton] at @s unless entity @e[tag=aj.yokovic.root,distance=..10] run function yokovic:summon/default

#Walking Animation
execute if score Yokovic boss.battle_tick matches 0.. as @e[tag=yokovic_Entity,type=wither_skeleton,nbt=!{Motion:[0.0d,0.0d,0.0d]}] at @s run execute as @e[tag=aj.yokovic.root] at @s run function yokovic:animations/walk/next_frame
execute if score Yokovic boss.battle_tick matches 0.. as @e[tag=yokovic_Entity,type=wither_skeleton,nbt={Motion:[0.0d,0.0d,0.0d]}] at @s run execute as @e[tag=aj.yokovic.root] at @s run function yokovic:animations/walk/pause
execute if score Yokovic boss.battle_tick matches 0.. as @e[tag=yokovic_Entity,type=wither_skeleton,nbt={Motion:[0.0d,0.0d,0.0d]}] at @s run execute as @e[tag=aj.yokovic.root] at @s run function yokovic:animations/base/next_frame
execute if score Yokovic boss.battle_tick matches -120..-5 as @e[tag=aj.yokovic.root] at @s run function yokovic:animations/spawn/next_frame
#execute if score Yokovic boss.battle_tick matches 0..2 as @e[tag=aj.yokovic.root] at @s run function yokovic:animations/spawn/stop
#Hurt particle
execute as @e[tag=yokovic_Entity,tag=hurt] at @s run particle damage_indicator ~ ~ ~ 0.4 0.4 0.4 0.5 5 force

#Attacking Animation
execute if score Yokovic boss.battle_tick matches 0.. as @e[tag=aj.yokovic.root,tag=!skill,tag=!dying] at @s if entity @e[type=#ally,distance=..4,tag=hurt] unless entity @e[tag=yokovic_attack,distance=..5] run summon area_effect_cloud ^ ^ ^1 {Duration:10,Tags:["yokovic_attack"]}
execute if score Yokovic boss.battle_tick matches 0.. as @e[tag=aj.yokovic.root,tag=!skill,tag=!dying] at @s if entity @e[type=#ally,distance=..4,tag=hurt] run execute as @e[tag=aj.yokovic.root] at @s run function yokovic:animations/attack/play
execute if score Yokovic boss.battle_tick matches 0.. as @e[tag=aj.yokovic.root,tag=!skill,tag=!dying] at @s if entity @e[type=#ally,distance=..4,tag=hurt] run execute as @e[tag=aj.yokovic.root] at @s run function yokovic:animations/walk/next_frame
execute if score Yokovic boss.battle_tick matches 0.. at @e[tag=yokovic_attack] run effect give @e[type=#ally,distance=..2] instant_damage 1 0 true
execute if score Yokovic boss.battle_tick matches 0.. as @e[tag=aj.yokovic.root,tag=!skill,tag=!dying] at @s if entity @e[type=#ally,distance=..4,tag=hurt] run particle block redstone_block ^ ^1 ^1.5 0.1 0.1 0.1 0.3 5 normal
execute if score Yokovic boss.battle_tick matches 0.. as @e[tag=aj.yokovic.root,tag=!skill,tag=!dying] at @s if entity @e[type=#ally,distance=..4,tag=hurt] run playsound entity.player.attack.strong neutral @a[distance=..10] ~ ~ ~ 1 1 0
#Skills
#Ancient Appraisal every bb tick 200
execute if score Yokovic boss.battle_tick matches 200 as @e[tag=yokovic,type=wither_skeleton] at @s run tellraw @a[distance=..30] {"text":"Yokovic is Summonning more of his Heralds!","color":"red","bold":true}
execute if score Yokovic boss.battle_tick matches 200 as @e[tag=yokovic,type=wither_skeleton] at @s run summon area_effect_cloud ~1 ~ ~ {Duration:40, Tags:["yokovic_AA_Anim"]}
execute if score Yokovic boss.battle_tick matches 200 as @e[tag=yokovic,type=wither_skeleton] at @s run summon area_effect_cloud ~-1 ~ ~ {Duration:40, Tags:["yokovic_AA_Anim"]}
execute as @e[tag=yokovic_AA_Anim,type=area_effect_cloud] at @s run particle dust_color_transition 0 0 0.3 2 0.3 0.3 0.3 ~ ~0.1 ~ 0.5 0 0.5 1 10 force
execute as @e[tag=yokovic_AA_Anim,type=area_effect_cloud] at @s run tp @s ^1 ^ ^0.1 facing entity @e[tag=yokovic,type=wither_skeleton,limit=1,sort=nearest]
execute if score Yokovic boss.battle_tick matches 200 at @e[tag=yokovic,type=wither_skeleton] run playsound minecraft:entity.evoker.prepare_summon player @a[distance= ..20] ~ ~ ~ 1 1
execute if score Yokovic boss.battle_tick matches 200 at @e[tag=yokovic,type=wither_skeleton] run playsound minecraft:entity.wither_skeleton.hurt player @a[distance= ..4] ~ ~ ~ 1 0 1
execute if score Yokovic boss.battle_tick matches 200 at @e[tag=yokovic,type=wither_skeleton] positioned ~ ~ ~2 run summon wither_skeleton ~ ~ ~ {CustomName:'[{"text":"Lv.1","color":"aqua","bold":true},{"text":" Yokovic\'s Herald","color":"red","bold":false}]',Health:40,Tags:["objective"],HandItems:[{id:iron_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1},{id:golden_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1}],HandDropChances:[0.00f,0.00f],ArmorItems:[{id:golden_boots,Count:1},{id:golden_leggings,Count:1},{id:iron_chestplate,Count:1},{id:iron_helmet,Count:1}],ArmorDropChances:[0.00f,0.00f,0.00f,0.00f],Attributes:[{Name:"generic.follow_range",Base:100f},{Name:"generic.knockback_resistance",Base:0.9f},{Name:"generic.max_health",Base:40F}]}
execute if score Yokovic boss.battle_tick matches 200 at @e[tag=yokovic,type=wither_skeleton] positioned ~ ~ ~-2 run summon wither_skeleton ~ ~ ~ {CustomName:'[{"text":"Lv.1","color":"aqua","bold":true},{"text":" Yokovic\'s Herald","color":"red","bold":false}]',Health:40,Tags:["objective"],HandItems:[{id:iron_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1},{id:golden_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1}],HandDropChances:[0.00f,0.00f],ArmorItems:[{id:golden_boots,Count:1},{id:golden_leggings,Count:1},{id:iron_chestplate,Count:1},{id:iron_helmet,Count:1}],ArmorDropChances:[0.00f,0.00f,0.00f,0.00f],Attributes:[{Name:"generic.follow_range",Base:100f},{Name:"generic.knockback_resistance",Base:0.9f},{Name:"generic.max_health",Base:40F}]}

execute if score Yokovic boss.battle_tick matches 200 if entity @e[tag=host,scores={md_difficulty=1..}] at @e[tag=yokovic,type=wither_skeleton] positioned ~2 ~ ~ run summon wither_skeleton ~ ~ ~ {CustomName:'[{"text":"Lv.2","color":"aqua","bold":true},{"text":" Yokovic\'s Herald","color":"red","bold":false}]',Health:60,Tags:["objective"],HandItems:[{id:iron_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1},{id:golden_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1}],HandDropChances:[0.00f,0.00f],ArmorItems:[{id:iron_boots,Count:1},{id:iron_leggings,Count:1},{id:iron_chestplate,Count:1},{id:golden_helmet,Count:1}],ArmorDropChances:[0.00f,0.00f,0.00f,0.00f],Attributes:[{Name:"generic.follow_range",Base:100f},{Name:"generic.knockback_resistance",Base:1f},{Name:"generic.max_health",Base:60F}]}
execute if score Yokovic boss.battle_tick matches 200 if entity @e[tag=host,scores={md_difficulty=1..}] at @e[tag=yokovic,type=wither_skeleton] positioned ~-2 ~ ~ run summon wither_skeleton ~ ~ ~ {CustomName:'[{"text":"Lv.2","color":"aqua","bold":true},{"text":" Yokovic\'s Herald","color":"red","bold":false}]',Health:60,Tags:["objective"],HandItems:[{id:iron_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1},{id:golden_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1}],HandDropChances:[0.00f,0.00f],ArmorItems:[{id:iron_boots,Count:1},{id:iron_leggings,Count:1},{id:iron_chestplate,Count:1},{id:golden_helmet,Count:1}],ArmorDropChances:[0.00f,0.00f,0.00f,0.00f],Attributes:[{Name:"generic.follow_range",Base:100f},{Name:"generic.knockback_resistance",Base:1f},{Name:"generic.max_health",Base:60F}]}

#Ancient Uproar Once when HP reach 50% or less
execute as @e[tag=yokovic_Entity,type=wither_skeleton,tag=!50_percent] if entity @e[tag=host,limit=1,scores={boss.storage.yokovic=..200}] run function ampsurv:boss/yokovic/50_percent

execute as @e[tag=yokovic_Entity,tag=skill,type=wither_skeleton] at @s if score Yokovic boss.battle_tick matches 100.. run function ampsurv:boss/yokovic/skill_au

#au_target
execute if entity @e[tag=au_target,type=area_effect_cloud] run function ampsurv:boss/yokovic/au

scoreboard players add Yokovic boss.battle_tick 1
execute if score Yokovic boss.battle_tick matches 600..610 as @e[tag=yokovic] run tag @e[tag=yokovic,tag=skill] remove skill
execute if score Yokovic boss.battle_tick matches 600..610 as @e[tag=yokovic] run scoreboard players set Yokovic boss.battle_tick 0

#Dying
execute as @e[tag=aj.yokovic.root,tag=!dying] at @s unless entity @e[tag=yokovic_Entity] run tellraw @a[distance=..50] {"text":"Yokovic had been defeated!","color":"light_purple","bold":true}
execute as @e[tag=aj.yokovic.root,tag=!dying] at @s unless entity @e[tag=yokovic_Entity] run summon item ~ ~ ~ {Item:{"id":"diamond_helmet",Count:1b,tag:{Unbreakable:1,display:{Name:'[{"text":"Helmet Of The Ancient One","italic":false,"color":"red","bold":true}]',Lore:['[{"text":"An armor piece that had"}]','[{"text":"been enchanted through","italic":true}]','[{"text":"time. It can be considered","italic":true}]','[{"text":"an artifact by now.","italic":true},{"text":"","italic":false}]','[{"text":"","italic":false}]','[{"text":"Ancient Rune:","italic":false,"color":"gold","underlined":true},{"text":"","italic":false,"color":"dark_purple","underlined":false}]','[{"text":"When worn, grant the","italic":false,"color":"gold"}]','[{"text":"wearer Bonus Max HP and","italic":false,"color":"gold"}]','[{"text":"Knockback Resistance","italic":false,"color":"gold"}]']},Enchantments:[{id:protection,lvl:5},{id:thorns,lvl:3}],AttributeModifiers:[{AttributeName:"generic.armor",Amount:3,Operation:0,UUID:[I;-121324,150030,213354,-300060],Slot:head,Name:"generic.armor"},{AttributeName:"generic.armor_toughness",Amount:0,Operation:0,UUID:[I;-121324,150130,213354,-300260],Slot:head,Name:"generic.armor_toughness"},{AttributeName:"generic.max_health",Amount:0.1,Operation:1,UUID:[I;-121324,150230,213354,-300460],Slot:head,Name:"generic.max_health"},{AttributeName:"generic.knockback_resistance",Amount:1,Operation:0,UUID:[I;-121324,150330,213354,-300660],Slot:head,Name:"generic.knockback_resistance"},{AttributeName:"generic.armor_toughness",Amount:2,Operation:0,UUID:[I;-121324,150430,213354,-300860],Slot:head,Name:"generic.armor_toughness"}]}}}
execute as @e[tag=aj.yokovic.root,tag=!dying] at @s unless entity @e[tag=yokovic_Entity] run summon item ~ ~ ~ {Item:{"id":"diamond_chestplate",Count:1b,tag:{Unbreakable:1,display:{Name:'[{"text":"Plate Of The Ancient One","italic":false,"color":"red","bold":true}]',Lore:['[{"text":"An armor piece that had"}]','[{"text":"been enchanted through","italic":true}]','[{"text":"time. It can be considered","italic":true}]','[{"text":"an artifact by now.","italic":true},{"text":"","italic":false}]','[{"text":"","italic":false}]','[{"text":"Ancient Rune:","italic":false,"color":"gold","underlined":true},{"text":"","italic":false,"color":"dark_purple","underlined":false}]','[{"text":"When worn, grant the","italic":false,"color":"gold"}]','[{"text":"wearer Bonus Max HP and","italic":false,"color":"gold"}]','[{"text":"Knockback Resistance","italic":false,"color":"gold"}]']},Enchantments:[{id:protection,lvl:5},{id:thorns,lvl:3}],AttributeModifiers:[{AttributeName:"generic.armor",Amount:8,Operation:0,UUID:[I;-121324,150030,213354,-300060],Slot:chest,Name:"generic.armor"},{AttributeName:"generic.armor_toughness",Amount:0,Operation:0,UUID:[I;-121324,150130,213354,-300260],Slot:chest,Name:"generic.armor_toughness"},{AttributeName:"generic.max_health",Amount:0.1,Operation:1,UUID:[I;-121324,150230,213354,-300460],Slot:chest,Name:"generic.max_health"},{AttributeName:"generic.knockback_resistance",Amount:1,Operation:0,UUID:[I;-121324,150330,213354,-300660],Slot:chest,Name:"generic.knockback_resistance"},{AttributeName:"generic.armor_toughness",Amount:2,Operation:0,UUID:[I;-121324,150430,213354,-300860],Slot:chest,Name:"generic.armor_toughness"}]}}}
execute as @e[tag=aj.yokovic.root,tag=!dying] at @s unless entity @e[tag=yokovic_Entity] run scoreboard players set Yokovic boss.battle_tick 611
execute as @e[tag=aj.yokovic.root,tag=!dying] at @s unless entity @e[tag=yokovic_Entity] run tag @s add dying

execute as @e[tag=aj.yokovic.root,tag=dying] at @s run function ampsurv:boss/yokovic/dying