#Yokovic Remake
execute as @e[tag=yokovic_Model,tag=!scened] at @s run scoreboard players set @a boss.battle_tick 0
execute as @e[tag=yokovic_Model,tag=!scened] at @s run scoreboard objectives add boss.storage.yokovic dummy
execute as @e[tag=yokovic_Model,tag=!scened] at @s run scoreboard players set @a boss.storage.yokovic 0
execute as @e[tag=yokovic_Model,tag=!scened] at @s run playsound minecraft:boss.yokovic.theme hostile @a[distance=..100] ~ ~ ~ 1 1 1
execute as @e[tag=yokovic_Model,tag=!scened] at @s run tag @s add scened
execute store result score @a boss.storage.yokovic run data get entity @e[tag=yokovic,limit=1,sort=nearest] Health

#Perma-effects
execute as @e[tag=yokovic] at @s anchored eyes run particle soul ~ ~ ~ 0.4 1 0.4 0 1 normal
execute as @e[tag=yokovic] at @s anchored eyes run particle dust_color_transition 0 0 0.3 2 0.3 0.3 0.3 ~ ~1 ~ 0.3 0.5 0.3 1 2 force
execute as @e[tag=yokovic] at @s anchored eyes run effect give @s invisibility 999999 1 true
execute as @e[tag=yokovic,tag=!res_down] at @s anchored eyes run effect give @s resistance 2 1 true
#Structural Construction
execute as @e[tag=yokovic_Entity,tag=!dying] at @s run tp @e[tag=yokovic_Model,limit=1,sort=nearest] ~ ~ ~ facing entity @p[gamemode=!spectator]
execute as @e[tag=yokovic_Entity,tag=!dying] at @s unless entity @e[tag=yokovic_Model,distance=..10] run summon armor_stand ~ ~ ~ {Tags:["yokovic_Model"],Invisible:1b,Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Marker:1b,ArmorItems:[{id:"netherite_boots",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1}},{id:"netherite_leggings",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1}},{id:"netherite_chestplate",Count:1b},{id:"player_head",Count:1b,tag:{SkullOwner:{Id:[I;-1772779268,980894116,-2141801327,1068751662],Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvZjIxMDJiMzgyZmFmMTc4M2E5Zjk4NWYyYzlhMzhkNWE4MzM3MzA0MGQ1ZDAxN2NhMTUzNTRhNWMzNzA0OGE5MiJ9fX0="}]}}}}],HandItems:[{id:"netherite_axe",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1}},{id:"netherite_axe",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1}}],Pose:{Head:[0f,0f,10f]}}

#Walking Animation
execute as @e[tag=yokovic_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]},tag=!skill] at @s if entity @p[scores={ally.anim_tick=0..3}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {RightLeg:[0f,0f,0f],LeftLeg:[360f,0f,0f],Head:[18f,0f,16f]}
execute as @e[tag=yokovic_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]},tag=!skill] at @s if entity @p[scores={ally.anim_tick=4..6}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {LeftLeg:[350f,0f,0f],RightLeg:[10f,0f,0f],Head:[18f,0f,16f]}
execute as @e[tag=yokovic_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]},tag=!skill] at @s if entity @p[scores={ally.anim_tick=7..10}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {LeftLeg:[340f,0f,0f],RightLeg:[20f,0f,0f],Head:[18f,0f,16f]}
execute as @e[tag=yokovic_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]},tag=!skill] at @s if entity @p[scores={ally.anim_tick=11..13}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {LeftLeg:[330f,0f,0f],RightLeg:[30f,0f,0f],Head:[18f,0f,16f]}
execute as @e[tag=yokovic_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]},tag=!skill] at @s if entity @p[scores={ally.anim_tick=14}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {LeftLeg:[340f,0f,0f],RightLeg:[20f,0f,0f],Head:[18f,0f,16f]}
execute as @e[tag=yokovic_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]},tag=!skill] at @s if entity @p[scores={ally.anim_tick=17}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {LeftLeg:[350f,0f,0f],RightLeg:[10f,0f,0f],Head:[18f,0f,16f]}
execute as @e[tag=yokovic_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]},tag=!skill] at @s if entity @p[scores={ally.anim_tick=20}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {RightLeg:[340f,0f,0f],LeftLeg:[20f,0f,0f],Head:[18f,0f,16f]}
execute as @e[tag=yokovic_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]},tag=!skill] at @s if entity @p[scores={ally.anim_tick=23}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {RightLeg:[330f,0f,0f],LeftLeg:[30f,0f,0f],Head:[18f,0f,16f]}
execute as @e[tag=yokovic_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]},tag=!skill] at @s if entity @p[scores={ally.anim_tick=26}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {RightLeg:[340f,0f,0f],LeftLeg:[20f,0f,0f],Head:[18f,0f,16f]}
execute as @e[tag=yokovic_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]},tag=!skill] at @s if entity @p[scores={ally.anim_tick=29}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {RightLeg:[350f,0f,0f],LeftLeg:[10f,0f,0f],Head:[18f,0f,16f]}

#Attacking Animation
execute as @e[tag=yokovic_Model,tag=!skill,tag=!attacking,tag=!dying] at @s if entity @e[type=#ally,distance=..10,tag=!hurt] run data modify entity @s Pose{} merge value {RightArm:[24f,44f,34f],LeftArm:[292f,0f,0f]}
execute as @e[tag=yokovic_Model,tag=!skill,tag=!attacking,tag=!dying] at @s if entity @e[type=#ally,distance=..3,tag=!hurt] run data modify entity @s Pose{} merge value {RightArm:[230f,0f,312f],LeftArm:[292f,0f,0f]}
execute as @e[tag=yokovic_Model,tag=!skill,tag=!dying] at @s if entity @e[type=#ally,distance=..4,tag=hurt] unless entity @e[tag=yokovic_attack,distance=..5] run summon area_effect_cloud ^ ^ ^1 {Duration:10,Tags:["yokovic_attack"]}
execute as @e[tag=yokovic_Model,tag=!skill,tag=!dying] at @s if entity @e[tag=yokovic_attack,distance=..5] run data modify entity @s Pose{} merge value {RightArm:[300f,0f,312f],LeftArm:[31f,0f,0f],Body:[0f,350f,0f]}
execute at @e[tag=yokovic_attack] run effect give @e[type=#ally,distance=..2] instant_damage 1 0 true
execute as @e[tag=yokovic_Model,tag=!skill,tag=!dying] at @s if entity @e[type=#ally,distance=..4,tag=hurt] run particle block redstone_block ^ ^1 ^1.5 0.1 0.1 0.1 0.3 5 normal
execute as @e[tag=yokovic_Model,tag=!skill,tag=!dying] at @s if entity @e[type=#ally,distance=..4,tag=hurt] run playsound entity.player.attack.strong neutral @a[distance=..10] ~ ~ ~ 1 1 0
#Skills
#Ancient Appraisal every bb tick 500
execute if entity @a[tag=host,scores={Difficulty=0..,boss.battle_tick=10}] as @e[tag=yokovic] at @s run tellraw @a[distance=..30] {"text":"Yokovic is Summonning more of his Heralds!","color":"red","bold":true}
execute if entity @a[tag=host,scores={md_difficulty=0..,boss.battle_tick=10}] as @e[tag=yokovic] at @s run summon area_effect_cloud ~1 ~ ~ {Duration:40, Tags:["yokovic_AA_Anim"]}
execute if entity @a[tag=host,scores={md_difficulty=0..,boss.battle_tick=10}] as @e[tag=yokovic] at @s run summon area_effect_cloud ~-1 ~ ~ {Duration:40, Tags:["yokovic_AA_Anim"]}
execute as @e[tag=yokovic_AA_Anim] at @s run particle dust_color_transition 0 0 0.3 2 0.3 0.3 0.3 ~ ~0.1 ~ 0.5 0 0.5 1 10 force
execute as @e[tag=yokovic_AA_Anim] at @s run tp @s ^1 ^ ^0.1 facing entity @e[tag=yokovic,limit=1,sort=nearest]
execute if entity @a[tag=host,scores={md_difficulty=0,boss.battle_tick=10}] at @e[tag=yokovic] run playsound minecraft:entity.evoker.prepare_summon player @a[distance= ..20] ~ ~ ~ 1 1
execute if entity @a[tag=host,scores={md_difficulty=0,boss.battle_tick=10}] at @e[tag=yokovic] run playsound minecraft:entity.wither_skeleton.hurt player @a[distance= ..4] ~ ~ ~ 1 0 1
execute if entity @a[tag=host,scores={md_difficulty=0,boss.battle_tick=10}] at @e[tag=yokovic] positioned ~ ~ ~2 run summon wither_skeleton ~ ~ ~ {CustomName:'[{"text":"Lv.1","color":"aqua","bold":true},{"text":" Yokovic\'s Herald","color":"red","bold":false}]',Health:40,Tags:["objective"],HandItems:[{id:iron_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1},{id:golden_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1}],HandDropChances:[0.00f,0.00f],ArmorItems:[{id:golden_boots,Count:1},{id:golden_leggings,Count:1},{id:iron_chestplate,Count:1},{id:iron_helmet,Count:1}],ArmorDropChances:[0.00f,0.00f,0.00f,0.00f],Attributes:[{Name:"generic.follow_range",Base:100f},{Name:"generic.knockback_resistance",Base:0.9f},{Name:"generic.max_health",Base:40F}]}
execute if entity @a[tag=host,scores={md_difficulty=0,boss.battle_tick=10}] at @e[tag=yokovic] positioned ~ ~ ~-2 run summon wither_skeleton ~ ~ ~ {CustomName:'[{"text":"Lv.1","color":"aqua","bold":true},{"text":" Yokovic\'s Herald","color":"red","bold":false}]',Health:40,Tags:["objective"],HandItems:[{id:iron_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1},{id:golden_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1}],HandDropChances:[0.00f,0.00f],ArmorItems:[{id:golden_boots,Count:1},{id:golden_leggings,Count:1},{id:iron_chestplate,Count:1},{id:iron_helmet,Count:1}],ArmorDropChances:[0.00f,0.00f,0.00f,0.00f],Attributes:[{Name:"generic.follow_range",Base:100f},{Name:"generic.knockback_resistance",Base:0.9f},{Name:"generic.max_health",Base:40F}]}

execute if entity @a[tag=host,scores={md_difficulty=1,boss.battle_tick=10}] at @e[tag=yokovic] run playsound minecraft:entity.evoker.prepare_summon player @a[distance= ..20] ~ ~ ~ 1 1
execute if entity @a[tag=host,scores={md_difficulty=1,boss.battle_tick=10}] at @e[tag=yokovic] run playsound minecraft:entity.wither_skeleton.hurt player @a[distance= ..4] ~ ~ ~ 1 0 1
execute if entity @a[tag=host,scores={md_difficulty=1,boss.battle_tick=10}] at @e[tag=yokovic] positioned ~ ~ ~2 run summon wither_skeleton ~ ~ ~ {CustomName:'[{"text":"Lv.2","color":"aqua","bold":true},{"text":" Yokovic\'s Herald","color":"red","bold":false}]',Health:60,Tags:["objective"],HandItems:[{id:iron_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1},{id:golden_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1}],HandDropChances:[0.00f,0.00f],ArmorItems:[{id:iron_boots,Count:1},{id:iron_leggings,Count:1},{id:iron_chestplate,Count:1},{id:golden_helmet,Count:1}],ArmorDropChances:[0.00f,0.00f,0.00f,0.00f],Attributes:[{Name:"generic.follow_range",Base:100f},{Name:"generic.knockback_resistance",Base:1f},{Name:"generic.max_health",Base:60F}]}
execute if entity @a[tag=host,scores={md_difficulty=1,boss.battle_tick=10}] at @e[tag=yokovic] positioned ~ ~ ~-2 run summon wither_skeleton ~ ~ ~ {CustomName:'[{"text":"Lv.2","color":"aqua","bold":true},{"text":" Yokovic\'s Herald","color":"red","bold":false}]',Health:60,Tags:["objective"],HandItems:[{id:iron_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1},{id:golden_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1}],HandDropChances:[0.00f,0.00f],ArmorItems:[{id:iron_boots,Count:1},{id:iron_leggings,Count:1},{id:iron_chestplate,Count:1},{id:golden_helmet,Count:1}],ArmorDropChances:[0.00f,0.00f,0.00f,0.00f],Attributes:[{Name:"generic.follow_range",Base:100f},{Name:"generic.knockback_resistance",Base:1f},{Name:"generic.max_health",Base:60F}]}
execute if entity @a[tag=host,scores={md_difficulty=1,boss.battle_tick=10}] at @e[tag=yokovic] positioned ~2 ~ ~ run summon wither_skeleton ~ ~ ~ {CustomName:'[{"text":"Lv.2","color":"aqua","bold":true},{"text":" Yokovic\'s Herald","color":"red","bold":false}]',Health:60,Tags:["objective"],HandItems:[{id:iron_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1},{id:golden_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1}],HandDropChances:[0.00f,0.00f],ArmorItems:[{id:iron_boots,Count:1},{id:iron_leggings,Count:1},{id:iron_chestplate,Count:1},{id:golden_helmet,Count:1}],ArmorDropChances:[0.00f,0.00f,0.00f,0.00f],Attributes:[{Name:"generic.follow_range",Base:100f},{Name:"generic.knockback_resistance",Base:1f},{Name:"generic.max_health",Base:60F}]}
execute if entity @a[tag=host,scores={md_difficulty=1,boss.battle_tick=10}] at @e[tag=yokovic] positioned ~-2 ~ ~ run summon wither_skeleton ~ ~ ~ {CustomName:'[{"text":"Lv.2","color":"aqua","bold":true},{"text":" Yokovic\'s Herald","color":"red","bold":false}]',Health:60,Tags:["objective"],HandItems:[{id:iron_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1},{id:golden_axe,tag:{Enchantments:[{id:protection,lvl:3}]},Count:1}],HandDropChances:[0.00f,0.00f],ArmorItems:[{id:iron_boots,Count:1},{id:iron_leggings,Count:1},{id:iron_chestplate,Count:1},{id:golden_helmet,Count:1}],ArmorDropChances:[0.00f,0.00f,0.00f,0.00f],Attributes:[{Name:"generic.follow_range",Base:100f},{Name:"generic.knockback_resistance",Base:1f},{Name:"generic.max_health",Base:60F}]}

#Ancient Uproar Once when HP reach 50% or less
execute as @e[tag=yokovic_Entity,tag=!50_percent] if entity @e[tag=host,limit=1,scores={boss.storage.yokovic=..200}] run tag @s add ancient_uproar
execute as @e[tag=yokovic_Entity,tag=!50_percent] if entity @e[tag=host,limit=1,scores={boss.storage.yokovic=..200}] run tag @s add skill
execute as @e[tag=yokovic_Entity,tag=!50_percent] if entity @e[tag=host,limit=1,scores={boss.storage.yokovic=..200}] run scoreboard players set @a boss.battle_tick 12
execute as @e[tag=yokovic_Entity,tag=!50_percent] if entity @e[tag=host,limit=1,scores={boss.storage.yokovic=..200}] run tag @s add 50_percent

execute as @e[tag=yokovic_Entity,tag=skill] at @s if entity @p[scores={boss.battle_tick=100..}] run effect give @s slowness 1 2 true
execute as @e[tag=yokovic_Entity,tag=skill] at @s if entity @p[scores={boss.battle_tick=100..}] run effect give @s resistance 1 3 true
execute as @e[tag=yokovic_Entity,tag=skill] at @s if entity @p[scores={boss.battle_tick=100..}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {Head:[40f,0f,0f],LeftArm:[170f,270f,105f],RightArm:[296f,94f,0f]}
execute as @e[tag=yokovic_Entity,tag=skill] at @s if entity @p[scores={boss.battle_tick=100..}] unless entity @e[tag=au_target_cd,type=area_effect_cloud] run execute at @e[type=#allyly,distance=..30,type=!area_effect_cloud,type=!falling_block] run summon area_effect_cloud ~ ~ ~ {Duration:35,Tags:["au_target"]}
execute as @e[tag=yokovic_Entity,tag=skill] at @s if entity @p[scores={boss.battle_tick=100..}] unless entity @e[tag=au_target_cd,type=area_effect_cloud] run summon area_effect_cloud ~ ~ ~ {Duration:50,Tags:["au_target_cd,type=area_effect_cloud"]}
execute as @e[tag=au_target,tag=!delayed] at @s unless entity @e[tag=au_delay,distance=..3] run summon area_effect_cloud ~ ~ ~ {Duration:20,Tags:["au_delay"]}
execute as @e[tag=au_target,tag=!delayed] at @s if entity @e[tag=au_delay,distance=..3] run tag @s add delayed
execute as @e[tag=au_target] at @s unless entity @e[tag=au_delay,distance=..3] run playsound minecraft:entity.iron_golem.damage player @a[distance=..15] ~ ~ ~ 1 0 0.3
execute as @e[tag=au_target] at @s run particle minecraft:block bedrock ~ ~ ~ 1.5 0 1.5 0 5 normal
execute as @e[tag=au_target] at @s run playsound minecraft:block.ancient_debris.break player @a[distance=..15] ~ ~ ~ 0.8 0 0.3
execute as @e[tag=au_target] at @s run playsound minecraft:entity.elder_guardian.ambient player @a[distance=..15] ~ ~ ~ 0.5 0 0.4

execute as @e[tag=au_target,tag=!animate] at @s unless entity @e[tag=au_delay,distance=..3] run summon falling_block ~ ~ ~ {BlockState:{Name:"minecraft:pointed_dripstone",Properties:{thickness:"middle",vertical_direction:"up",waterlogged:"false"}},Time:570,NoGravity:1b,DropItem:0b}
execute as @e[tag=au_target,tag=!animate] at @s unless entity @e[tag=au_delay,distance=..3] run summon falling_block ~ ~1 ~ {BlockState:{Name:"minecraft:pointed_dripstone",Properties:{thickness:"frustum",vertical_direction:"up",waterlogged:"false"}},Time:570,NoGravity:1b,DropItem:0b}
execute as @e[tag=au_target,tag=!animate] at @s unless entity @e[tag=au_delay,distance=..3] run summon falling_block ~ ~2 ~ {BlockState:{Name:"minecraft:pointed_dripstone",Properties:{thickness:"tip",vertical_direction:"up",waterlogged:"false"}},Time:570,NoGravity:1b,DropItem:0b}
execute as @e[tag=au_target,tag=!animate] at @s unless entity @e[tag=au_delay,distance=..3] run tag @s add animate

execute as @e[tag=au_target] at @s unless entity @e[tag=au_delay,distance=..3] run particle minecraft:explosion ~ ~ ~ 1 0 1 0 1 normal
execute as @e[tag=au_target] at @s unless entity @e[tag=au_delay,distance=..3] run particle minecraft:totem_of_undying ~ ~ ~ 0 0 0 0.5 10 normal
execute as @e[tag=au_target] at @s unless entity @e[tag=au_delay,distance=..3] run particle minecraft:instant_effect ~ ~ ~ 0.3 0 0.3 1 10 normal

execute as @e[tag=au_target] at @s unless entity @e[tag=au_delay,distance=..3] run effect give @e[type=#ally,distance=..4] instant_damage 1 0 true
execute as @e[tag=au_target] at @s run effect give @e[type=#ally,distance=..4] slowness 1 2 true

execute if entity @a[tag=host,scores={boss.battle_tick=600..610}] as @e[tag=yokovic] run tag @e[tag=yokovic,tag=skill] remove skill
execute if entity @a[tag=host,scores={boss.battle_tick=600..610}] as @e[tag=yokovic] run scoreboard players set @a boss.battle_tick 0

#Dying
execute as @e[tag=yokovic_Model,tag=!dying] at @s unless entity @e[tag=yokovic_Entity] run tellraw @a[distance=..50] {"text":"Yokovic had been defeated!","color":"light_purple","bold":true}
execute as @e[tag=yokovic_Model,tag=!dying] at @s unless entity @e[tag=yokovic_Entity] run summon item ~ ~ ~ {Item:{"id":"diamond_helmet",Count:1b,tag:{Unbreakable:1,display:{Name:'[{"text":"Helmet Of The Ancient One","italic":false,"color":"red","bold":true}]',Lore:['[{"text":"An armor piece that had"}]','[{"text":"been enchanted through","italic":true}]','[{"text":"time. It can be considered","italic":true}]','[{"text":"an artifact by now.","italic":true},{"text":"","italic":false}]','[{"text":"","italic":false}]','[{"text":"Ancient Rune:","italic":false,"color":"gold","underlined":true},{"text":"","italic":false,"color":"dark_purple","underlined":false}]','[{"text":"When worn, grant the","italic":false,"color":"gold"}]','[{"text":"wearer Bonus Max HP and","italic":false,"color":"gold"}]','[{"text":"Knockback Resistance","italic":false,"color":"gold"}]']},Enchantments:[{id:protection,lvl:5},{id:thorns,lvl:3}],AttributeModifiers:[{AttributeName:"generic.armor",Amount:3,Operation:0,UUID:[I;-121324,150030,213354,-300060],Slot:head,Name:"generic.armor"},{AttributeName:"generic.armor_toughness",Amount:0,Operation:0,UUID:[I;-121324,150130,213354,-300260],Slot:head,Name:"generic.armor_toughness"},{AttributeName:"generic.max_health",Amount:0.1,Operation:1,UUID:[I;-121324,150230,213354,-300460],Slot:head,Name:"generic.max_health"},{AttributeName:"generic.knockback_resistance",Amount:1,Operation:0,UUID:[I;-121324,150330,213354,-300660],Slot:head,Name:"generic.knockback_resistance"},{AttributeName:"generic.armor_toughness",Amount:2,Operation:0,UUID:[I;-121324,150430,213354,-300860],Slot:head,Name:"generic.armor_toughness"}]}}}
execute as @e[tag=yokovic_Model,tag=!dying] at @s unless entity @e[tag=yokovic_Entity] run summon item ~ ~ ~ {Item:{"id":"diamond_chestplate",Count:1b,tag:{Unbreakable:1,display:{Name:'[{"text":"Plate Of The Ancient One","italic":false,"color":"red","bold":true}]',Lore:['[{"text":"An armor piece that had"}]','[{"text":"been enchanted through","italic":true}]','[{"text":"time. It can be considered","italic":true}]','[{"text":"an artifact by now.","italic":true},{"text":"","italic":false}]','[{"text":"","italic":false}]','[{"text":"Ancient Rune:","italic":false,"color":"gold","underlined":true},{"text":"","italic":false,"color":"dark_purple","underlined":false}]','[{"text":"When worn, grant the","italic":false,"color":"gold"}]','[{"text":"wearer Bonus Max HP and","italic":false,"color":"gold"}]','[{"text":"Knockback Resistance","italic":false,"color":"gold"}]']},Enchantments:[{id:protection,lvl:5},{id:thorns,lvl:3}],AttributeModifiers:[{AttributeName:"generic.armor",Amount:8,Operation:0,UUID:[I;-121324,150030,213354,-300060],Slot:chest,Name:"generic.armor"},{AttributeName:"generic.armor_toughness",Amount:0,Operation:0,UUID:[I;-121324,150130,213354,-300260],Slot:chest,Name:"generic.armor_toughness"},{AttributeName:"generic.max_health",Amount:0.1,Operation:1,UUID:[I;-121324,150230,213354,-300460],Slot:chest,Name:"generic.max_health"},{AttributeName:"generic.knockback_resistance",Amount:1,Operation:0,UUID:[I;-121324,150330,213354,-300660],Slot:chest,Name:"generic.knockback_resistance"},{AttributeName:"generic.armor_toughness",Amount:2,Operation:0,UUID:[I;-121324,150430,213354,-300860],Slot:chest,Name:"generic.armor_toughness"}]}}}
execute as @e[tag=yokovic_Model,tag=!dying] at @s unless entity @e[tag=yokovic_Entity] run scoreboard players set @a boss.battle_tick 611
execute as @e[tag=yokovic_Model,tag=!dying] at @s unless entity @e[tag=yokovic_Entity] run tag @s add dying

execute if entity @a[tag=host,scores={boss.battle_tick=611..}] as @e[tag=yokovic_Model,tag=dying] run scoreboard players add @a boss.battle_tick 1
execute as @e[tag=yokovic_Model,tag=dying] if entity @a[tag=host,scores={boss.battle_tick=612..620}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {Head:[280f,0f,0f],LeftArm:[282f,288f,0f],RightArm:[282f,1f,0f]}
execute as @e[tag=yokovic_Model,tag=dying] if entity @a[tag=host,scores={boss.battle_tick=621..630}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {Head:[290f,0f,0f],LeftArm:[292f,298f,0f],RightArm:[292f,11f,0f]}
execute as @e[tag=yokovic_Model,tag=dying] if entity @a[tag=host,scores={boss.battle_tick=631..640}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {Head:[300f,0f,0f],LeftArm:[302f,308f,0f],RightArm:[302f,21f,0f]}
execute as @e[tag=yokovic_Model,tag=dying] if entity @a[tag=host,scores={boss.battle_tick=641..650}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {Head:[310f,0f,0f],LeftArm:[312f,318f,0f],RightArm:[312f,31f,0f]}
execute as @e[tag=yokovic_Model,tag=dying] if entity @a[tag=host,scores={boss.battle_tick=651..}] run data modify entity @e[limit=1,sort=nearest,tag=yokovic_Model] Pose{} merge value {Head:[320f,0f,0f],LeftArm:[322f,328f,0f],RightArm:[322f,41f,0f]}
execute as @e[tag=yokovic_Model,tag=dying] at @s if entity @a[tag=host,scores={boss.battle_tick=615..616}] run playsound entity.wither.death hostile @a[distance=..50] ~ ~ ~ 1 2 0.2
execute as @e[tag=yokovic_Model,tag=dying] at @s if entity @a[tag=host,scores={boss.battle_tick=615..}] run particle soul ~ ~1 ~ 0 0 0 0.3 5 force
execute as @e[tag=yokovic_Model,tag=dying] at @s if entity @a[tag=host,scores={boss.battle_tick=615..}] run particle soul_fire_flame ~ ~1 ~ 0.3 0.5 0.3 0.01 10 force
execute as @e[tag=yokovic_Model,tag=dying] if entity @a[tag=host,scores={boss.battle_tick=740}] run scoreboard objectives remove boss.storage.yokovic
execute as @e[tag=yokovic_Model,tag=dying] if entity @a[tag=host,scores={boss.battle_tick=740}] run kill @s