
execute if score worldScore opening_scene matches 2 positioned -386 64 156 run function midland:cutscene/opening/change_scene
execute if score worldScore opening_scene matches 3..4 run tp @a -386 64 156 92 2
execute if score worldScore opening_scene matches 5..2000 run execute as @a[tag=cutscene_opening] run spectate @e[tag=spectated_entity,limit=1,type=armor_stand]
execute if score worldScore opening_scene matches 5..22 run tp @e[tag=spectated_entity] -386 64 156 92 2
execute if score worldScore opening_scene matches 23..303 run execute as @e[tag=spectated_entity] at @s run tp @s ~ ~ ~0.1

#astaria
execute if score worldScore opening_scene matches 295 run title @a title {"text":"\uA002"}
execute if score worldScore opening_scene matches 304..305 run time set 13000t
execute if score worldScore opening_scene matches 304 positioned -121 32 393 run function midland:cutscene/opening/change_scene
execute if score worldScore opening_scene matches 304..305 run tp @a[tag=cutscene_opening] -121 32 393 -1.5 6.7
execute if score worldScore opening_scene matches 306..310 run tp @e[tag=spectated_entity] -121 32 393 -1.5 6.7
execute if score worldScore opening_scene matches 311..511 run execute as @e[tag=spectated_entity] at @s run tp @s ~-0.15 ~ ~

execute if score worldScore opening_scene matches 500 run title @a title {"text":"\uA002"}
execute if score worldScore opening_scene matches 512 run tp @e[tag=spectated_entity] -106 33 399 -40.9 3.1
execute if score worldScore opening_scene matches 512..612 run execute as @e[tag=spectated_entity] at @s run tp @s ~ ~0.02 ~

#midland
execute if score worldScore opening_scene matches 600 run title @a title {"text":"\uA002"}
execute if score worldScore opening_scene matches 601 positioned -302 48 -79 run function midland:cutscene/opening/change_scene
execute if score worldScore opening_scene matches 612..615 run tp @e[tag=spectated_entity] -302 48 -79 -78.2 13.1
execute if score worldScore opening_scene matches 612..812 run execute as @e[tag=spectated_entity] at @s run tp @s ^ ^ ^0.05

#castle
execute if score worldScore opening_scene matches 802 run title @a title {"text":"\uA002"}
execute if score worldScore opening_scene matches 802 run time set 14000t
execute if score worldScore opening_scene matches 803 positioned -161 67 250 run function midland:cutscene/opening/change_scene
execute if score worldScore opening_scene matches 812..815 run tp @e[tag=spectated_entity] -160 50 272 0 -16.7
execute if score worldScore opening_scene matches 816..1200 run execute as @e[tag=spectated_entity] at @s run tp @s ^ ^ ^0.05
execute if score worldScore opening_scene matches 960 run title @a reset
execute if score worldScore opening_scene matches 960 run title @a times 20 100 20
execute if score worldScore opening_scene matches 961 run title @a title {"text":"- Midland -","bold":false,"color":"white","font":"dwarvesc"}
execute if score worldScore opening_scene matches 1000 run title @a subtitle {"text":"- A Red Cross Knight Story - ","bold":false,"color":"red"}
execute if score worldScore opening_scene matches 1020 run title @a actionbar {"text":"- By JekNJok -","bold":true,"color":"gold"}
execute if score worldScore opening_scene matches 1088 run title @a reset
execute if score worldScore opening_scene matches 1100 run title @a times 10 10 10

#enter loop

#area 1 - Cliffhearth mine entrance
execute if score worldScore opening_scene matches 1103 run execute as @a run function midland:cutscene/opening/end_action
execute if score worldScore opening_scene matches 1090 run title @a title {"text":"\uA002"}
execute if score worldScore opening_scene matches 1103 positioned -355 33 -77 run function midland:cutscene/opening/change_scene
execute if score worldScore opening_scene matches 1104 run tp @e[tag=spectated_entity] -355 33 -77 90 0
execute if score worldScore opening_scene matches 1105..1303 run execute as @e[tag=spectated_entity] at @s run tp @s ~-0.1 ~ ~

#area 2 - old altar spring
execute if score worldScore opening_scene matches 1304 run execute as @a run function midland:cutscene/opening/end_action
execute if score worldScore opening_scene matches 1290 run title @a title {"text":"\uA002"}
execute if score worldScore opening_scene matches 1304 positioned -409 15 -17 run function midland:cutscene/opening/change_scene
execute if score worldScore opening_scene matches 1305 run tp @e[tag=spectated_entity] -409 15 -17 -59 -6
execute if score worldScore opening_scene matches 1306..1503 run execute as @e[tag=spectated_entity] at @s run tp @s ^ ^ ^0.1

#area 3 - Narthex Pinnacle Dream
execute if score worldScore opening_scene matches 1503 run execute as @a run function midland:cutscene/opening/end_action
execute if score worldScore opening_scene matches 1490 run title @a title {"text":"\uA002"}
execute if score worldScore opening_scene matches 1503 positioned -467 14 242 run function midland:cutscene/opening/change_scene
execute if score worldScore opening_scene matches 1504 run tp @e[tag=spectated_entity] -467 14 242 154 -7
execute if score worldScore opening_scene matches 1505..1703 run execute as @e[tag=spectated_entity] at @s run tp @s ^ ^ ^0.03

#area 4 - Zerr Cave Bridge
execute if score worldScore opening_scene matches 1703 run execute as @a run function midland:cutscene/opening/end_action
execute if score worldScore opening_scene matches 1690 run title @a title {"text":"\uA002"}
execute if score worldScore opening_scene matches 1703 positioned -390 63 215 run function midland:cutscene/opening/change_scene
execute if score worldScore opening_scene matches 1704 run tp @e[tag=spectated_entity] -390 63 215 -90 12.9
execute if score worldScore opening_scene matches 1705..1903 run execute as @e[tag=spectated_entity] at @s run tp @s ~0.05 ~ ~

#area 5 - Guild Library
execute if score worldScore opening_scene matches 1903 run execute as @a run function midland:cutscene/opening/end_action
execute if score worldScore opening_scene matches 1890 run title @a title {"text":"\uA002"}
execute if score worldScore opening_scene matches 1903 positioned -172 31 -61 run function midland:cutscene/opening/change_scene
execute if score worldScore opening_scene matches 1904 run tp @e[tag=spectated_entity] -172 31 -61 178 1.4
execute if score worldScore opening_scene matches 1905..2103 run execute as @e[tag=spectated_entity] at @s run tp @s ~ ~ ~-0.05

#reset loop 
execute if score worldScore opening_scene matches 2103.. run scoreboard players set worldScore opening_scene 1089